<template>
  <a-config-provider :locale="locale">
    <a-layout :class="['layout', device]">
      <!-- SideMenu -->
      <a-drawer
        v-if="isMobile()"
        :wrap-class-name="`drawer-sider ${navTheme}`"
        :closable="false"
        :visible="collapsed"
        @close="drawerClose"
        placement="left"
      >
        <side-menu
          :menus="menus"
          :theme="navTheme"
          :collapsed="false"
          :collapsible="true"
          @menuSelect="menuSelect"
          mode="inline"
        />
      </a-drawer>

      <side-menu
        v-else-if="isSideMenu()"
        :menus="menus"
        :theme="navTheme"
        :collapsed="collapsed"
        :collapsible="true"
        mode="inline"
      />

      <a-layout
        :class="[layoutMode, `content-width-${contentWidth}`]"
        :style="{ paddingLeft: contentPaddingLeft, minHeight: '100vh' }"
      >
        <!-- layout header -->
        <global-header
          :mode="layoutMode"
          :menus="menus"
          :theme="navTheme"
          :collapsed="collapsed"
          :device="device"
          @toggle="toggle"
        />

        <!-- layout content -->
        <a-layout-content
          :style="{
            height: '100%',
            margin: '24px 24px 0',
            paddingTop: fixedHeader ? '64px' : '0'
          }"
        >
          <multi-tab v-if="multiTab" />
          <transition name="page-transition">
            <route-view />
          </transition>
        </a-layout-content>

        <!-- layout footer -->
        <a-layout-footer>
          <global-footer />
        </a-layout-footer>

        <!-- Setting Drawer (show in development mode) -->
        <!-- <setting-drawer /> -->
      </a-layout>
    </a-layout>
  </a-config-provider>
</template>

<script>
import { mapActions, mapGetters } from 'vuex'
import vi from 'ant-design-vue/lib/locale-provider/vi_VN'
import { triggerWindowResizeEvent } from '@/utils/util'
import { mixin, mixinDevice, AppDeviceEnquire } from '@/utils/mixin'
import { config } from '@/config/defaultSettings'
import MultiTab from '@/components/MultiTab'
import SideMenu from '@/components/Menu/SideMenu'
import GlobalHeader from '@/components/GlobalHeader'
import GlobalFooter from '@/components/GlobalFooter'
import SettingDrawer from '@/components/SettingDrawer'
import RouteView from './RouteView'
// import { asyncRouterMap } from '@/config/router.config'

export default {
  components: {
    RouteView,
    MultiTab,
    SideMenu,
    GlobalHeader,
    GlobalFooter,
    // eslint-disable-next-line vue/no-unused-components
    SettingDrawer
  },
  mixins: [mixin, mixinDevice, AppDeviceEnquire],
  data () {
    return {
      production: config.production,
      collapsed: false,
      menus: []
    }
  },
  middleware: 'authenticated',
  computed: {
    ...mapGetters('permission', ['addRouters']),
    contentPaddingLeft () {
      if (!this.fixSidebar || this.isMobile()) {
        return '0'
      }
      if (this.sidebarOpened) {
        return '256px'
      }
      return '80px'
    },
    locale () {
      return vi
    }
  },
  watch: {
    sidebarOpened (val) {
      this.collapsed = !val
    }
  },
  created () {
    // this.menus = this.mainMenu
    this.menus = this.addRouters.find(item => item.path === '/').children
    this.collapsed = !this.sidebarOpened
  },
  mounted () {
    const userAgent = navigator.userAgent
    if (userAgent.includes('Edge')) {
      this.$nextTick(() => {
        this.collapsed = !this.collapsed
        setTimeout(() => {
          this.collapsed = !this.collapsed
        }, 16)
      })
    }
  },

  methods: {
    ...mapActions('app', ['setSidebar']),
    toggle () {
      this.collapsed = !this.collapsed
      this.setSidebar(!this.collapsed)
      triggerWindowResizeEvent()
    },
    paddingCalc () {
      let left = ''
      if (this.sidebarOpened) {
        left = this.isDesktop() ? '256px' : '80px'
      } else {
        left = (this.isMobile() && '0') || (this.fixSidebar && '80px') || '0'
      }
      return left
    },
    menuSelect () {
      if (!this.isDesktop()) {
        this.collapsed = false
      }
    },
    drawerClose () {
      this.collapsed = false
    }
  }
}
</script>

<style lang="less">
@import url('../components/global.less');

/*
 * The following styles are auto-applied to elements with
 * transition="page-transition" when their visibility is toggled
 * by Vue.js.
 *
 * You can easily play with the page transition by editing
 * these styles.
 */

.page-transition-enter {
  opacity: 0;
}

.page-transition-leave-active {
  opacity: 0;
}

.page-transition-enter .page-transition-container,
.page-transition-leave-active .page-transition-container {
  -webkit-transform: scale(1.1);
  transform: scale(1.1);
}
</style>
